
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="English">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>plant_ls &#8212; PLAnT 0.0.21dev documentation</title>
    <link rel="stylesheet" href="../_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '0.0.21dev',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true,
        SOURCELINK_SUFFIX: '.txt'
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
  </head>
  <body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">PLAnT 0.0.21dev documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for plant_ls</h1><div class="highlight"><pre>
<span></span><span class="ch">#!/usr/bin/env python3</span>
<span class="c1"># ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</span>
<span class="c1">#</span>
<span class="c1"># Author: Gustavo H. X. Shiroma, Marco Lavalle</span>
<span class="c1"># Copyright 2010-2011, by the California Institute of Technology. ALL RIGHTS</span>
<span class="c1"># RESERVED. United States Government Sponsorship acknowledged.</span>
<span class="c1"># Any commercial use must be negotiated with the Office of Technology Transfer</span>
<span class="c1"># at the California Institute of Technology.</span>
<span class="c1">#</span>
<span class="c1"># This software may be subject to U.S. export control laws. By accepting this</span>
<span class="c1"># software, the user agrees to comply with all applicable U.S.</span>
<span class="c1"># export laws and regulations. User has the responsibility to obtain export</span>
<span class="c1"># licenses, or other export authority as may be required before exporting such</span>
<span class="c1"># information to foreign countries or providing access to foreign persons.</span>
<span class="c1">#</span>
<span class="c1"># ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~</span>

<span class="kn">from</span> <span class="nn">os</span> <span class="k">import</span> <span class="n">path</span><span class="p">,</span> <span class="n">stat</span>
<span class="kn">import</span> <span class="nn">shutil</span>
<span class="kn">import</span> <span class="nn">plant</span>


<span class="k">def</span> <span class="nf">get_parser</span><span class="p">():</span>
    <span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Command line parser.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="n">descr</span> <span class="o">=</span> <span class="s1">&#39;List files&#39;</span>
    <span class="n">epilog</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span>
    <span class="n">parser</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">argparse</span><span class="p">(</span><span class="n">epilog</span><span class="o">=</span><span class="n">epilog</span><span class="p">,</span>
                            <span class="n">description</span><span class="o">=</span><span class="n">descr</span><span class="p">,</span>
                            <span class="n">input_files</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                            <span class="n">output_file</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;-i&#39;</span><span class="p">,</span> <span class="s1">&#39;--images&#39;</span><span class="p">,</span>
                        <span class="n">dest</span><span class="o">=</span><span class="s1">&#39;image&#39;</span><span class="p">,</span>
                        <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                        <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span>
                        <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Show images only.&#39;</span><span class="p">,</span>
                        <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;-e&#39;</span><span class="p">,</span> <span class="s1">&#39;--headers&#39;</span><span class="p">,</span>
                        <span class="n">dest</span><span class="o">=</span><span class="s1">&#39;header&#39;</span><span class="p">,</span>
                        <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                        <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span>
                        <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Show headers onlly.&#39;</span><span class="p">,</span>
                        <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;-d&#39;</span><span class="p">,</span> <span class="s1">&#39;--directory&#39;</span><span class="p">,</span>
                        <span class="s1">&#39;--directories&#39;</span><span class="p">,</span>
                        <span class="n">dest</span><span class="o">=</span><span class="s1">&#39;directory&#39;</span><span class="p">,</span>
                        <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                        <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span>
                        <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Show directories only.&#39;</span><span class="p">,</span>
                        <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;-r&#39;</span><span class="p">,</span> <span class="s1">&#39;--regular&#39;</span><span class="p">,</span>
                        <span class="n">dest</span><span class="o">=</span><span class="s1">&#39;regular&#39;</span><span class="p">,</span>
                        <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                        <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span>
                        <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Regular files only.&#39;</span><span class="p">,</span>
                        <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;-l&#39;</span><span class="p">,</span> <span class="s1">&#39;--human&#39;</span><span class="p">,</span>
                        <span class="n">dest</span><span class="o">=</span><span class="s1">&#39;human&#39;</span><span class="p">,</span>
                        <span class="n">required</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                        <span class="n">action</span><span class="o">=</span><span class="s1">&#39;store_true&#39;</span><span class="p">,</span>
                        <span class="n">help</span><span class="o">=</span><span class="s1">&#39;Print sizes in human readable format.&#39;</span><span class="p">,</span>
                        <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">parser</span>


<div class="viewcode-block" id="PlantLS"><a class="viewcode-back" href="../code.html#plant_ls.PlantLS">[docs]</a><span class="k">class</span> <span class="nc">PlantLS</span><span class="p">(</span><span class="n">plant</span><span class="o">.</span><span class="n">PlantScript</span><span class="p">):</span>

    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">parser</span><span class="p">,</span> <span class="n">argv</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&#39;&#39;&#39;</span>
<span class="sd">        class initialization</span>
<span class="sd">        &#39;&#39;&#39;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">parser</span><span class="p">,</span> <span class="n">argv</span><span class="p">)</span>

    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&#39;&#39;&#39;</span>
<span class="sd">        Run filter</span>
<span class="sd">        &#39;&#39;&#39;</span>

        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">input_files</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">input_files</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;*&#39;</span><span class="p">]</span>
        <span class="k">elif</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">input_files</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span> <span class="ow">and</span>
              <span class="n">path</span><span class="o">.</span><span class="n">isdir</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">input_files</span><span class="p">[</span><span class="mi">0</span><span class="p">])):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">input_files</span> <span class="o">=</span> <span class="p">[</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">input_files</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="s1">&#39;*&#39;</span><span class="p">)]</span>

        <span class="n">filelist</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">current_input</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">input_files</span><span class="p">:</span>
            <span class="n">input_expanded</span> <span class="o">=</span> <span class="n">path</span><span class="o">.</span><span class="n">expanduser</span><span class="p">(</span><span class="n">current_input</span><span class="p">)</span>
            <span class="n">current_filelist</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">get_files_from_list</span><span class="p">([</span><span class="n">input_expanded</span><span class="p">])</span>
            <span class="k">for</span> <span class="n">current_file</span> <span class="ow">in</span> <span class="n">current_filelist</span><span class="p">:</span>
                <span class="n">filelist</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">current_file</span><span class="p">)</span>

        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">filelist</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">print</span><span class="p">(</span><span class="s1">&#39;ERROR file not found&#39;</span><span class="p">)</span>
            <span class="k">return</span>
        <span class="n">column_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="n">ret_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">current_file</span> <span class="ow">in</span> <span class="n">filelist</span><span class="p">:</span>
            <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">list_file</span><span class="p">(</span><span class="n">current_file</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">ret</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">print</span><span class="p">(</span><span class="s1">&#39;WARNING file not found. &#39;</span>
                           <span class="s1">&#39;Ignoring: </span><span class="si">%s</span><span class="s1">&#39;</span>
                           <span class="o">%</span> <span class="n">current_file</span><span class="p">)</span>
                <span class="k">continue</span>
            <span class="n">type_str</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;type&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">image</span> <span class="ow">and</span> <span class="n">type_str</span> <span class="o">!=</span> <span class="s1">&#39;image&#39;</span><span class="p">:</span>
                <span class="k">continue</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">header</span> <span class="ow">and</span> <span class="n">type_str</span> <span class="o">!=</span> <span class="s1">&#39;header&#39;</span><span class="p">:</span>
                <span class="k">continue</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">directory</span> <span class="ow">and</span> <span class="n">type_str</span> <span class="o">!=</span> <span class="s1">&#39;directory&#39;</span><span class="p">:</span>
                <span class="k">continue</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">regular</span> <span class="ow">and</span> <span class="n">type_str</span> <span class="o">!=</span> <span class="s1">&#39;regular&#39;</span><span class="p">:</span>
                <span class="k">continue</span>
            <span class="n">ret_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">ret</span><span class="p">)</span>

        <span class="n">column_size_filename</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">column_size_file_format</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">column_size_dtype</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">column_size_shape</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="n">column_size_nbands</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">for</span> <span class="n">ret</span> <span class="ow">in</span> <span class="n">ret_list</span><span class="p">:</span>
            <span class="n">current_file</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;filename&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">current_file_format</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;file_format&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">current_dtype</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;dtype&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">current_shape</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;shape&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">current_nbands</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;nbands&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">current_file</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span>
                    <span class="p">(</span><span class="n">column_size_filename</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span>
                     <span class="nb">len</span><span class="p">(</span><span class="n">current_file</span><span class="p">)</span> <span class="o">&gt;</span> <span class="n">column_size_filename</span><span class="p">)):</span>
                <span class="n">column_size_filename</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">current_file</span><span class="p">)</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">current_file_format</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span>
                    <span class="p">(</span><span class="n">column_size_file_format</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span>
                     <span class="nb">len</span><span class="p">(</span><span class="n">current_file_format</span><span class="p">)</span> <span class="o">&gt;</span> <span class="n">column_size_file_format</span><span class="p">)):</span>
                <span class="n">column_size_file_format</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">current_file_format</span><span class="p">)</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">current_dtype</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span>
                    <span class="p">(</span><span class="n">column_size_dtype</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span>
                     <span class="nb">len</span><span class="p">(</span><span class="n">current_dtype</span><span class="p">)</span> <span class="o">&gt;</span> <span class="n">column_size_dtype</span><span class="p">)):</span>
                <span class="n">column_size_dtype</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">current_dtype</span><span class="p">)</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">current_shape</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span>
                    <span class="p">(</span><span class="n">column_size_shape</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span>
                     <span class="nb">len</span><span class="p">(</span><span class="n">current_shape</span><span class="p">)</span> <span class="o">&gt;</span> <span class="n">column_size_shape</span><span class="p">)):</span>
                <span class="n">column_size_shape</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">current_shape</span><span class="p">)</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">current_nbands</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span>
                    <span class="p">(</span><span class="n">column_size_nbands</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span>
                     <span class="nb">len</span><span class="p">(</span><span class="n">current_nbands</span><span class="p">)</span> <span class="o">&gt;</span> <span class="n">column_size_nbands</span><span class="p">)):</span>
                <span class="n">column_size_nbands</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">current_nbands</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">column_size_filename</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">column_size_filename</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="n">column_size_file_format</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">column_size_file_format</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="n">column_size_dtype</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">column_size_dtype</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="n">column_size_shape</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">column_size_shape</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="k">if</span> <span class="n">column_size_nbands</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">column_size_nbands</span> <span class="o">=</span> <span class="mi">0</span>

        <span class="n">file_size_len</span> <span class="o">=</span> <span class="mi">14</span> <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">human</span> <span class="k">else</span> <span class="mi">10</span>
        <span class="n">column_length</span> <span class="o">=</span> <span class="p">(</span><span class="n">column_size_filename</span> <span class="o">+</span>
                         <span class="n">column_size_file_format</span> <span class="o">+</span>
                         <span class="n">column_size_dtype</span> <span class="o">+</span>
                         <span class="n">column_size_shape</span> <span class="o">+</span>
                         <span class="n">column_size_nbands</span> <span class="o">+</span>
                         <span class="n">file_size_len</span> <span class="o">+</span> <span class="mi">6</span><span class="p">)</span>
        <span class="n">terminal_width</span> <span class="o">=</span> <span class="n">shutil</span><span class="o">.</span><span class="n">get_terminal_size</span><span class="p">()</span><span class="o">.</span><span class="n">columns</span>
        <span class="n">n_columns</span> <span class="o">=</span> <span class="nb">int</span><span class="p">((</span><span class="n">terminal_width</span><span class="p">)</span><span class="o">/</span><span class="n">column_length</span><span class="p">)</span>

        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">ret</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">ret_list</span><span class="p">):</span>
            <span class="n">current_file</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;filename&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">dtype_str</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;dtype&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">file_type</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;type&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">file_format_str</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;file_format&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">file_size</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;file_size&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">shape_str</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;shape&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
            <span class="n">nbands_str</span> <span class="o">=</span> <span class="n">ret</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;nbands&#39;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>

            <span class="n">current_file</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span> <span class="k">if</span> <span class="n">current_file</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">current_file</span>
            <span class="n">dtype_str</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span> <span class="k">if</span> <span class="n">dtype_str</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">dtype_str</span>
            <span class="n">file_type</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span> <span class="k">if</span> <span class="n">file_type</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">file_type</span>
            <span class="n">file_format_str</span> <span class="o">=</span> \
                <span class="s1">&#39;&#39;</span> <span class="k">if</span> <span class="n">file_format_str</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">file_format_str</span>
            <span class="n">file_size</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span> <span class="k">if</span> <span class="n">file_size</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">file_size</span>
            <span class="n">shape_str</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span> <span class="k">if</span> <span class="n">shape_str</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">shape_str</span>
            <span class="n">nbands_str</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span> <span class="k">if</span> <span class="n">nbands_str</span> <span class="ow">is</span> <span class="kc">None</span> <span class="k">else</span> <span class="n">nbands_str</span>

            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">human</span> <span class="ow">and</span> <span class="n">file_size</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">file_size_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">get_file_size_string</span><span class="p">(</span><span class="n">file_size</span><span class="p">)</span>
            <span class="k">elif</span> <span class="n">file_size</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">file_size_str</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="si">%8d</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="n">file_size</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">file_size_str</span> <span class="o">=</span> <span class="s1">&#39; &#39;</span><span class="o">*</span><span class="n">file_size_len</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">human</span><span class="p">:</span>
                <span class="n">file_size_str</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="si">%10s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="n">file_size_str</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">file_size_str</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="si">%14s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="n">file_size_str</span>

            <span class="k">if</span> <span class="p">((</span><span class="n">path</span><span class="o">.</span><span class="n">islink</span><span class="p">(</span><span class="n">current_file</span><span class="p">)</span> <span class="ow">or</span>
                 <span class="n">current_file</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="s1">&#39;.vrt&#39;</span><span class="p">))</span> <span class="ow">and</span>
                    <span class="p">(</span><span class="n">file_type</span> <span class="o">==</span> <span class="s1">&#39;image&#39;</span> <span class="ow">or</span>
                     <span class="n">file_type</span> <span class="o">==</span> <span class="s1">&#39;header&#39;</span><span class="p">)):</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">BCyan</span>
            <span class="k">elif</span> <span class="n">path</span><span class="o">.</span><span class="n">islink</span><span class="p">(</span><span class="n">current_file</span><span class="p">):</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">Cyan</span>
            <span class="k">elif</span> <span class="p">(</span><span class="n">file_type</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span>
                    <span class="n">file_type</span> <span class="o">==</span> <span class="s1">&#39;regular&#39;</span><span class="p">):</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">ColorOff</span>
            <span class="k">elif</span> <span class="n">file_type</span> <span class="o">==</span> <span class="s1">&#39;directory&#39;</span><span class="p">:</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">BBlue</span>
            <span class="k">elif</span> <span class="n">file_type</span> <span class="o">==</span> <span class="s1">&#39;header&#39;</span><span class="p">:</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">Purple</span>
            <span class="k">elif</span> <span class="p">(</span><span class="n">file_type</span> <span class="o">==</span> <span class="s1">&#39;image&#39;</span> <span class="ow">and</span>
                  <span class="n">file_format_str</span> <span class="o">==</span> <span class="s1">&#39;VIRTUAL&#39;</span><span class="p">):</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">BYellow</span>
            <span class="k">elif</span> <span class="p">(</span><span class="n">file_type</span> <span class="o">==</span> <span class="s1">&#39;image&#39;</span> <span class="ow">and</span>
                  <span class="n">file_format_str</span> <span class="ow">in</span> <span class="n">plant</span><span class="o">.</span><span class="n">FIG_DRIVERS</span><span class="p">):</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">BPurple</span>
            <span class="k">elif</span> <span class="n">file_type</span> <span class="o">==</span> <span class="s1">&#39;image&#39;</span><span class="p">:</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">BGreen</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">color_str</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">ColorOff</span>

            <span class="n">current_file_str</span> <span class="o">=</span> <span class="p">(</span><span class="n">color_str</span> <span class="o">+</span> <span class="n">current_file</span> <span class="o">+</span>
                                <span class="n">plant</span><span class="o">.</span><span class="n">bcolors</span><span class="o">.</span><span class="n">ColorOff</span><span class="p">)</span>
            <span class="n">current_file_str</span> <span class="o">+=</span> <span class="s1">&#39; &#39;</span><span class="o">*</span><span class="p">(</span><span class="n">column_size_filename</span> <span class="o">-</span>
                                     <span class="nb">len</span><span class="p">(</span><span class="n">current_file</span><span class="p">))</span>
            <span class="n">file_format_str</span> <span class="o">+=</span> <span class="s1">&#39; &#39;</span><span class="o">*</span><span class="p">(</span><span class="n">column_size_file_format</span> <span class="o">-</span>
                                    <span class="nb">len</span><span class="p">(</span><span class="n">file_format_str</span><span class="p">))</span>
            <span class="n">dtype_str</span> <span class="o">+=</span> <span class="s1">&#39; &#39;</span><span class="o">*</span><span class="p">(</span><span class="n">column_size_dtype</span> <span class="o">-</span>
                              <span class="nb">len</span><span class="p">(</span><span class="n">dtype_str</span><span class="p">))</span>
            <span class="n">shape_str</span> <span class="o">+=</span> <span class="s1">&#39; &#39;</span><span class="o">*</span><span class="p">(</span><span class="n">column_size_shape</span> <span class="o">-</span>
                              <span class="nb">len</span><span class="p">(</span><span class="n">shape_str</span><span class="p">))</span>
            <span class="n">nbands_str</span> <span class="o">+=</span> <span class="s1">&#39; &#39;</span><span class="o">*</span><span class="p">(</span><span class="n">column_size_nbands</span> <span class="o">-</span>
                               <span class="nb">len</span><span class="p">(</span><span class="n">nbands_str</span><span class="p">))</span>
            <span class="n">column_str</span> <span class="o">=</span> <span class="s1">&#39;&#39;</span>
            <span class="k">if</span> <span class="n">file_size_str</span><span class="p">:</span>
                <span class="n">column_str</span> <span class="o">+=</span> <span class="n">file_size_str</span><span class="o">+</span><span class="s1">&#39; &#39;</span>
            <span class="k">if</span> <span class="n">dtype_str</span><span class="p">:</span>
                <span class="n">column_str</span> <span class="o">+=</span> <span class="n">dtype_str</span><span class="o">+</span><span class="s1">&#39; &#39;</span>
            <span class="k">if</span> <span class="n">file_format_str</span><span class="p">:</span>
                <span class="n">column_str</span> <span class="o">+=</span> <span class="n">file_format_str</span><span class="o">+</span><span class="s1">&#39; &#39;</span>
            <span class="k">if</span> <span class="n">shape_str</span><span class="p">:</span>
                <span class="n">column_str</span> <span class="o">+=</span> <span class="n">shape_str</span><span class="o">+</span><span class="s1">&#39; &#39;</span>
            <span class="k">if</span> <span class="n">nbands_str</span><span class="p">:</span>
                <span class="n">column_str</span> <span class="o">+=</span> <span class="n">nbands_str</span><span class="o">+</span><span class="s1">&#39; &#39;</span>
            <span class="k">if</span> <span class="n">current_file_str</span><span class="p">:</span>
                <span class="n">column_str</span> <span class="o">+=</span> <span class="n">current_file_str</span><span class="o">+</span><span class="s1">&#39; &#39;</span>
            <span class="n">column_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">column_str</span><span class="p">)</span>
            <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">column_list</span><span class="p">)</span> <span class="o">==</span> <span class="n">n_columns</span> <span class="ow">or</span>
                    <span class="n">i</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">filelist</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">):</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">print</span><span class="p">(</span><span class="s1">&#39;&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">column_list</span><span class="p">))</span>
                <span class="n">column_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">column_list</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">print</span><span class="p">(</span><span class="s1">&#39;&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">column_list</span><span class="p">))</span>

    <span class="k">def</span> <span class="nf">list_file</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">current_file</span><span class="p">):</span>
        <span class="n">ret_dict</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="c1"># ret_dict[&#39;nbands&#39;] = &#39;&#39;</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">file_size</span> <span class="o">=</span> <span class="n">stat</span><span class="p">(</span><span class="n">current_file</span><span class="p">)</span><span class="o">.</span><span class="n">st_size</span>
            <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;file_size&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">file_size</span>
        <span class="k">except</span> <span class="ne">FileNotFoundError</span><span class="p">:</span>
            <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;file_size&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>

        <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;filename&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">current_file</span>
        <span class="k">if</span> <span class="n">path</span><span class="o">.</span><span class="n">isdir</span><span class="p">(</span><span class="n">current_file</span><span class="p">):</span>
            <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;type&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;directory&#39;</span>
            <span class="k">return</span> <span class="n">ret_dict</span>
        <span class="n">image_obj</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">read_image</span><span class="p">(</span><span class="n">current_file</span><span class="p">,</span>
                                    <span class="n">only_header</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                                    <span class="n">flag_exit_if_error</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                                    <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">image_obj</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="ow">not</span> <span class="n">path</span><span class="o">.</span><span class="n">isfile</span><span class="p">(</span><span class="n">current_file</span><span class="p">):</span>
                <span class="k">return</span>
            <span class="k">if</span> <span class="nb">any</span><span class="p">([</span><span class="n">current_file</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="n">ext</span><span class="p">)</span>
                    <span class="k">for</span> <span class="n">ext</span> <span class="ow">in</span> <span class="n">plant</span><span class="o">.</span><span class="n">HEADER_EXTENSIONS</span><span class="p">]):</span>
                <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;type&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;header&#39;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;type&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;regular&#39;</span>
            <span class="k">return</span> <span class="n">ret_dict</span>
        <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;dtype&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">plant</span><span class="o">.</span><span class="n">get_dtype_name</span><span class="p">(</span><span class="n">image_obj</span><span class="o">.</span><span class="n">dtype</span><span class="p">)</span>
        <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;file_format&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">image_obj</span><span class="o">.</span><span class="n">file_format</span>

        <span class="k">if</span> <span class="n">image_obj</span><span class="o">.</span><span class="n">length</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">shape_str</span> <span class="o">=</span> <span class="p">(</span><span class="s1">&#39;</span><span class="si">%d</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="n">image_obj</span><span class="o">.</span><span class="n">width</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">image_obj</span><span class="o">.</span><span class="n">depth</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">shape_str</span> <span class="o">=</span> <span class="p">(</span><span class="s1">&#39;</span><span class="si">%d</span><span class="s1">x</span><span class="si">%d</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">image_obj</span><span class="o">.</span><span class="n">length</span><span class="p">,</span>
                                    <span class="n">image_obj</span><span class="o">.</span><span class="n">width</span><span class="p">))</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">shape_str</span> <span class="o">=</span> <span class="p">(</span><span class="s1">&#39;</span><span class="si">%d</span><span class="s1">x</span><span class="si">%d</span><span class="s1">x</span><span class="si">%d</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">image_obj</span><span class="o">.</span><span class="n">depth</span><span class="p">,</span>
                                       <span class="n">image_obj</span><span class="o">.</span><span class="n">length</span><span class="p">,</span>
                                       <span class="n">image_obj</span><span class="o">.</span><span class="n">width</span><span class="p">))</span>
        <span class="k">if</span> <span class="n">image_obj</span><span class="o">.</span><span class="n">nbands</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;nbands&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39; </span><span class="si">%d</span><span class="s1"> bands&#39;</span> <span class="o">%</span> <span class="n">image_obj</span><span class="o">.</span><span class="n">nbands</span>
        <span class="k">if</span> <span class="nb">any</span><span class="p">([</span><span class="n">current_file</span><span class="o">.</span><span class="n">endswith</span><span class="p">(</span><span class="n">ext</span><span class="p">)</span>
                <span class="k">for</span> <span class="n">ext</span> <span class="ow">in</span> <span class="n">plant</span><span class="o">.</span><span class="n">HEADER_EXTENSIONS</span><span class="p">]):</span>
            <span class="n">shape_str</span> <span class="o">=</span> <span class="n">shape_str</span>
            <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;type&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;header&#39;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">shape_str</span> <span class="o">=</span> <span class="n">shape_str</span>
            <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;type&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;image&#39;</span>
        <span class="n">ret_dict</span><span class="p">[</span><span class="s1">&#39;shape&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">shape_str</span>
        <span class="k">return</span> <span class="n">ret_dict</span></div>


<span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">argv</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
    <span class="k">with</span> <span class="n">plant</span><span class="o">.</span><span class="n">PlantLogger</span><span class="p">():</span>
        <span class="n">parser</span> <span class="o">=</span> <span class="n">get_parser</span><span class="p">()</span>
        <span class="n">self_obj</span> <span class="o">=</span> <span class="n">PlantLS</span><span class="p">(</span><span class="n">parser</span><span class="p">,</span> <span class="n">argv</span><span class="p">)</span>
        <span class="n">ret</span> <span class="o">=</span> <span class="n">self_obj</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">ret</span>


<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">main</span><span class="p">()</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <div><input type="text" name="q" /></div>
      <div><input type="submit" value="Go" /></div>
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">PLAnT 0.0.21dev documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2017, Gustavo H. X. Shiroma, Marco Lavalle.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.6.5.
    </div>
  </body>
</html>